import { Component, OnInit, ViewChild } from '@angular/core';
import { Router } from '@angular/router';
import { STComponent, STColumn, STChange } from '@delon/abc/st';
import { SFComponent, SFSchema, SFDateWidgetSchema } from '@delon/form';
import { NzModalService } from 'ng-zorro-antd/modal';
import { TicketService } from 'src/app/routes/ticket-management/services/system.service';

@Component({
  selector: 'app-withdrawals-record',
  templateUrl: './withdrawals-record.component.html',
  styleUrls: ['./withdrawals-record.component.less']
})
export class WithdrawalsRecordComponent implements OnInit {
  url = `/rule?_allow_anonymous=true`;
  @ViewChild('st', { static: true })
  st!: STComponent;
  @ViewChild('sf', { static: false })
  sf!: SFComponent;
  @ViewChild('auditModal', { static: false })
  auditModal!: any;
  columns: STColumn[] = [
    { title: '', index: 'key', type: 'checkbox' },
    { title: '提现时间', index: 'no' },
    { title: '提现单号', index: 'callNo' },
    { title: '账户主体', index: 'callNo' },
    { title: '账户名称', index: 'callNo' },
    { title: '虚拟账户', index: 'callNo' },
    { title: '账户类型', index: 'callNo' },
    { title: '提现金额', index: 'callNo' },
    { title: '提现手续费', index: 'callNo' },
    { title: '银行账户', index: 'callNo' },
    { title: '提现状态', index: 'callNo' },
    {
      title: '操作',
      buttons: [
        {
          text: '审核',
          click: item => this.auditAction(item)
        },
        {
          text: '详情',
          click: item => this.routeTo(item)
        }
      ]
    }
  ];
  searchSchema: SFSchema = {
    properties: {
      expand: {
        type: 'boolean',
        ui: {
          hidden: true
        }
      },
      orderSn: {
        type: 'string',
        title: '提现单号',
        ui: {
          autocomplete: 'off'
        }
      },
      receiveName: {
        type: 'string',
        title: '提现状态',
        enum: [
          { label: '全部', value: '全部' },
          { label: '待审核', value: '待审核' },
          { label: '处理中', value: '处理中' },
          { label: '已完成', value: '已完成' },
          { label: '已拒绝', value: '已拒绝' }
        ],
        ui: {
          widget: 'select',
          placeholder: '请选择',
          change: (i: any) => {
            this.sf.value.receiveName = i;
            this.sf?.setValue('/receiveName', i);
          }
        }
      },
      createTime: {
        title: '提现时间',
        type: 'string',
        ui: {
          widget: 'date',
          mode: 'range',
          format: 'yyyy-MM-dd'
        } as SFDateWidgetSchema
      },
      orderSn2: {
        type: 'string',
        title: '账户名称',
        ui: {
          placeholder: '请输入',
          autocomplete: 'off',
          visibleIf: {
            expand: (value: boolean) => value
          }
        }
      },
      receiveName2: {
        type: 'string',
        title: '账户类型',
        enum: [
          { label: '全部', value: '全部' },
          { label: '个人', value: '个人' },
          { label: '企业', value: '企业' }
        ],
        ui: {
          widget: 'select',
          placeholder: '请选择',
          change: (i: any) => {
            this.sf.value.receiveName2 = i;
            this.sf?.setValue('/receiveName2', i);
          },
          visibleIf: {
            expand: (value: boolean) => value
          }
        }
      },
      receiveName3: {
        type: 'string',
        title: '账户主体',
        enum: [{ label: '全部', value: '全部' }],
        ui: {
          widget: 'select',
          placeholder: '请选择',
          change: (i: any) => {
            this.sf.value.receiveName3 = i;
            this.sf?.setValue('/receiveName3', i);
          },
          visibleIf: {
            expand: (value: boolean) => value
          }
        }
      }
    }
  };

  reqParams = {};

  _$expand = false;

  selectedRows: any[] = [];
  totalCallNo = 0;
  constructor(public service: TicketService, private nzModalService: NzModalService, private router: Router) {}

  ngOnInit(): void {}

  stChange(e: STChange): void {
    switch (e.type) {
      case 'checkbox':
        this.selectedRows = e.checkbox!;
        this.totalCallNo = this.selectedRows.reduce((total, cv) => total + cv.callNo, 0);
        break;
      case 'filter':
        this.st.load();
        break;
    }
  }

  approval(): void {}

  add(): void {}

  routeTo(item: any) {
    this.router.navigate(['/financial-management/withdrawals-detail/1']);
  }

  auditAction(item: any) {
    const modal = this.nzModalService.create({
      nzTitle: '审核',
      nzContent: this.auditModal,
      nzFooter: [
        {
          label: '拒绝',
          type: 'default',
          onClick: () => {
            modal.destroy();
          }
        },
        {
          label: '通过',
          type: 'primary',
          onClick: () => {
            modal.destroy();
          }
        }
      ]
    });
    modal.afterClose.subscribe(res => {
      this.st.load();
    });
  }

  showReason(item: any) {
    const modal = this.nzModalService.create({
      nzTitle: '查看原因',
      nzContent: '运单数据异常，暂时无法开票，请联系客服400-xxxx-xxxx',
      nzFooter: [
        {
          label: '关闭',
          type: 'primary',
          onClick: () => {
            modal.destroy();
          }
        }
      ]
    });
  }

  /**
   * 重置表单
   */
  resetSF() {
    this.sf.reset();
    this._$expand = false;
  }

  /**
   * 伸缩查询条件
   */
  expandToggle() {
    this._$expand = !this._$expand;
    this.sf?.setValue('/expand', this._$expand);
  }
}
